import { vitest } from 'vitest';
import { type RouteLocation } from 'vue-router';

import { type MountingOptions, shallowMount } from '@vue/test-utils';
import dayjs from 'dayjs';
import sinon, { type SinonStubbedInstance } from 'sinon';

import UtenteAppService from '@/entities/utente-app/utente-app.service';
import AlertService from '@/shared/alert/alert.service';
import { DATE_TIME_LONG_FORMAT } from '@/shared/composables/date-format';

import AuditLogUpdate from './audit-log-update.vue';
import AuditLogService from './audit-log.service';

type AuditLogUpdateComponentType = InstanceType<typeof AuditLogUpdate>;

let route: Partial<RouteLocation>;
const routerGoMock = vitest.fn();

vitest.mock('vue-router', () => ({
  useRoute: () => route,
  useRouter: () => ({ go: routerGoMock }),
}));

const auditLogSample = { id: 123 };

describe('Component Tests', () => {
  let mountOptions: MountingOptions<AuditLogUpdateComponentType>['global'];
  let alertService: AlertService;

  describe('AuditLog Management Update Component', () => {
    let comp: AuditLogUpdateComponentType;
    let auditLogServiceStub: SinonStubbedInstance<AuditLogService>;

    beforeEach(() => {
      route = {};
      auditLogServiceStub = sinon.createStubInstance<AuditLogService>(AuditLogService);
      auditLogServiceStub.retrieve.onFirstCall().resolves(Promise.resolve([]));

      alertService = new AlertService({
        i18n: { t: vitest.fn() } as any,
        toast: {
          show: vitest.fn(),
        } as any,
      });

      mountOptions = {
        stubs: {
          'font-awesome-icon': true,
          'b-input-group': true,
          'b-input-group-prepend': true,
          'b-form-datepicker': true,
          'b-form-input': true,
        },
        provide: {
          alertService,
          auditLogService: () => auditLogServiceStub,
          utenteAppService: () =>
            sinon.createStubInstance<UtenteAppService>(UtenteAppService, {
              retrieve: sinon.stub().resolves({}),
            } as any),
        },
      };
    });

    afterEach(() => {
      vitest.resetAllMocks();
    });

    describe('load', () => {
      beforeEach(() => {
        const wrapper = shallowMount(AuditLogUpdate, { global: mountOptions });
        comp = wrapper.vm;
      });
      it('Should convert date from string', () => {
        // GIVEN
        const date = new Date('2019-10-15T11:42:02Z');

        // WHEN
        const convertedDate = comp.convertDateTimeFromServer(date);

        // THEN
        expect(convertedDate).toEqual(dayjs(date).format(DATE_TIME_LONG_FORMAT));
      });

      it('Should not convert date if date is not present', () => {
        expect(comp.convertDateTimeFromServer(null)).toBeNull();
      });
    });

    describe('save', () => {
      it('Should call update service on save for existing entity', async () => {
        // GIVEN
        const wrapper = shallowMount(AuditLogUpdate, { global: mountOptions });
        comp = wrapper.vm;
        comp.auditLog = auditLogSample;
        auditLogServiceStub.update.resolves(auditLogSample);

        // WHEN
        comp.save();
        await comp.$nextTick();

        // THEN
        expect(auditLogServiceStub.update.calledWith(auditLogSample)).toBeTruthy();
        expect(comp.isSaving).toEqual(false);
      });

      it('Should call create service on save for new entity', async () => {
        // GIVEN
        const entity = {};
        auditLogServiceStub.create.resolves(entity);
        const wrapper = shallowMount(AuditLogUpdate, { global: mountOptions });
        comp = wrapper.vm;
        comp.auditLog = entity;

        // WHEN
        comp.save();
        await comp.$nextTick();

        // THEN
        expect(auditLogServiceStub.create.calledWith(entity)).toBeTruthy();
        expect(comp.isSaving).toEqual(false);
      });
    });

    describe('Before route enter', () => {
      it('Should retrieve data', async () => {
        // GIVEN
        auditLogServiceStub.find.resolves(auditLogSample);
        auditLogServiceStub.retrieve.resolves([auditLogSample]);

        // WHEN
        route = {
          params: {
            auditLogId: `${auditLogSample.id}`,
          },
        };
        const wrapper = shallowMount(AuditLogUpdate, { global: mountOptions });
        comp = wrapper.vm;
        await comp.$nextTick();

        // THEN
        expect(comp.auditLog).toMatchObject(auditLogSample);
      });
    });

    describe('Previous state', () => {
      it('Should go previous state', async () => {
        auditLogServiceStub.find.resolves(auditLogSample);
        const wrapper = shallowMount(AuditLogUpdate, { global: mountOptions });
        comp = wrapper.vm;
        await comp.$nextTick();

        comp.previousState();
        await comp.$nextTick();

        expect(routerGoMock).toHaveBeenCalledWith(-1);
      });
    });
  });
});
